<?php

namespace App\Entity;

use App\Repository\ResetPasswordRequestRepository;
use Doctrine\ORM\Mapping as ORM;
use SymfonyCasts\Bundle\ResetPassword\Model\ResetPasswordRequestInterface;
use SymfonyCasts\Bundle\ResetPassword\Model\ResetPasswordRequestTrait;

#[ORM\Table(name:'reset_password_request')]
#[ORM\Entity(repositoryClass:ResetPasswordRequestRepository::class)]
class ResetPasswordRequest implements ResetPasswordRequestInterface
{
    use ResetPasswordRequestTrait;

    #[ORM\Id]
    #[ORM\Column(name:'id', type:'integer')]
    #[ORM\GeneratedValue(strategy:'IDENTITY')]
    private int $id;

    #[ORM\ManyToOne(targetEntity:User::class)]
    #[ORM\JoinColumn(nullable:false)]
    private User $user;

    public function __construct(User $user, \DateTimeInterface $expires_at, string $selector, string $hashed_token)
    {
        $this->user = $user;
        $this->initialize($expires_at, $selector, $hashed_token);
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUser(): User
    {
        return $this->user;
    }
}
